use crate::name_analysis::symbol::Symbol;
use std::borrow::Cow;
use std::range::Range;

pub trait Named {
    fn name(&self) -> Cow<'_, str>;

    fn file_id(&self) -> usize;
    fn range(&self) -> Range<usize>;

    fn set_scope_id(&mut self, scope_id: usize);
    fn scope_id(&self) -> Option<usize>;

    fn set_saved_symbol(&mut self, symbol: Symbol);
    fn saved_symbol(&self) -> Option<Symbol>;
}
