use crate::ast::node::type_use::TypeUse;

#[derive(Debug)]
pub struct TupleArguments(Vec<Box<TypeUse>>);

impl TupleArguments {
    pub fn new(arguments: Vec<Box<TypeUse>>) -> Self {
        Self(arguments)
    }

    pub fn is_empty(&self) -> bool {
        self.0.is_empty()
    }

    pub fn type_uses(&self) -> Vec<&TypeUse> {
        self.0.iter().map(Box::as_ref).collect()
    }

    pub fn type_uses_mut(&mut self) -> Vec<&mut TypeUse> {
        self.0.iter_mut().map(Box::as_mut).collect()
    }
}
